
' --------------------------------------------------------------
' Example file for the BV4627 8 way relay when using the USB
' interface
' --------------------------------------------------------------
'
' --------------------------------------------------------------
' start up
' --------------------------------------------------------------
   call  doComm "5"         ' open com port, change for your system
   call doPause "500"       ' needed after opening comm
   ' Only needed once at reset
   print #comm, chr$(13);   ' only needed once
   call doPause "500"
   '
   call  doCmd "[o"        ' all relays on
    for j = 65 to 72
        command$="[0,"+str$((j*5)-300)+chr$(j)
        call doCmd command$
        print command$ ' just shows o/p
    next
    close #comm
' --------------------------------------------------------------
' send a command, just saves having to put chr$(27) in front
' of everything
' --------------------------------------------------------------
sub doCmd cmd$
    print #comm, chr$(27);
    print #comm, cmd$
end sub

' --------------------------------------------------------------
' waits for comm buffer and looks for a specified character
' if found simply returns, if not prints error after waiting
' a number of iterations. Use this to wait for a response from
' external device ** Cant do zeroes **
' --------------------------------------------------------------
sub doWait value
    err = 200
    for j = 1 to err
        print j,
        if value = asc(input$(#comm,1)) then exit for
    next
    if j > err then print "ACK Error"
end sub
'
' --------------------------------------------------------------
' pauses here for x number of milliseconds
' --------------------------------------------------------------
sub doPause mil$
    mil = val(mil$)
    t=time$("milliseconds")
    while time$("milliseconds")<t+mil
    scan
    wend
end sub
'
' --------------------------------------------------------------
' Open comm port
' Use in the form  call doComm "5" to open com port 5
' --------------------------------------------------------------
sub doComm  portnum$
    oncomerror [comcatch]
    'Set the size of the communications buffer to 16K
    Com = 8192 * 2
    cpt$ = "COM"+portnum$+":115200,n,8,2,ds0,cs0,rs"
    open cpt$ for random as #comm
    print "Comm port ";portnum$;" open"
    oncomerror
    goto [comokay]
[comcatch]
    print "Error opening comm port ";portnum$
    print "No port open"
[comokay]
end sub
'

