// BV4627

constant ADR 0x64

function r8_init
    i2copen 1 400000
endf

function i2_adr
dim j
    i2copen 1 100000
    for j = 2 to 240 step 2
        if i2ctest(1,j) = 1 then
            print "I2C Found address ";j,hex$(j)
        endif
    next
endf

// *****************************************************************************
// send a command
// *****************************************************************************
function r8_cmd(cmd)
    i2cstart 1 ADR
    i2cput(1,cmd)
    i2cstop 1
endf
    
// *****************************************************************************
// get value 8 bit
// *****************************************************************************
function r8_get8(cmd)
dim rv
    r8_cmd(cmd)
    i2cstart 1 ADR+1
    rv=i2cget(1,1)
    i2cstop 1
    result rv
endf    

// *****************************************************************************
// get value 16 bit
// *****************************************************************************
function r8_get16
dim rv
    i2cstart 1 ADR+1
    rv=i2cget(1,0)*256
    rv=rv+i2cget(1,1)
    i2cstop 1
    result rv
endf    

// *****************************************************************************
// turns relay on or off with a delay, set ron=1 for on and 0 for off
// *****************************************************************************
function r8_rly(rly, ron, delay)
dim delh, dell
    delh=and(rshift(delay,8),0xff)
    dell=and(delay, 0xff) 
    i2cstart 1 ADR
    i2cput(1,rly)
    i2cput(1,ron)
    i2cput(1,delh)
    i2cput(1,dell)
    i2cstop 1 
endf

// switch on all relays and then timed off
function go
dim j
    r8_cmd(19)
    for j=10 to 17
        r8_rly(j,0,j*5)
    next
endf

    

        